Index: trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.cpp	(revision 94004)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.cpp	(revision 94005)
@@ -257,12 +257,12 @@
 
 /* Obsolete keys: */
-QMap<QString, QString> UIExtraDataDefs::prepareObsoleteKeysMap()
+QMultiMap<QString, QString> UIExtraDataDefs::prepareObsoleteKeysMap()
 {
-    QMap<QString, QString> map;
-    map.insertMulti(GUI_Details_Elements, GUI_DetailsPageBoxes);
-    map.insertMulti(GUI_Details_Elements_Preview_UpdateInterval, GUI_PreviewUpdate);
+    QMultiMap<QString, QString> map;
+    map.insert(GUI_Details_Elements, GUI_DetailsPageBoxes);
+    map.insert(GUI_Details_Elements_Preview_UpdateInterval, GUI_PreviewUpdate);
     return map;
 }
-QMap<QString, QString> UIExtraDataDefs::g_mapOfObsoleteKeys = UIExtraDataDefs::prepareObsoleteKeysMap();
+QMultiMap<QString, QString> UIExtraDataDefs::g_mapOfObsoleteKeys = UIExtraDataDefs::prepareObsoleteKeysMap();
 
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.h	(revision 94004)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.h	(revision 94005)
@@ -470,8 +470,8 @@
       * @{ */
         /** Prepares obsolete keys map. */
-        SHARED_LIBRARY_STUFF QMap<QString, QString> prepareObsoleteKeysMap();
+        SHARED_LIBRARY_STUFF QMultiMap<QString, QString> prepareObsoleteKeysMap();
 
         /** Holds the obsolete keys map. */
-        SHARED_LIBRARY_STUFF extern QMap<QString, QString> g_mapOfObsoleteKeys;
+        SHARED_LIBRARY_STUFF extern QMultiMap<QString, QString> g_mapOfObsoleteKeys;
     /** @} */
 }
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIShortcutConfigurationEditor.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIShortcutConfigurationEditor.cpp	(revision 94004)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIShortcutConfigurationEditor.cpp	(revision 94005)
@@ -405,5 +405,5 @@
 {
     /* Enumerate all the sequences: */
-    QMap<QString, QString> usedSequences;
+    QMultiMap<QString, QString> usedSequences;
     foreach (const UIShortcutTableViewRow &item, m_shortcuts)
     {
@@ -413,5 +413,5 @@
             const QString strScope = item.scope();
             strKey = strScope.isNull() ? strKey : QString("%1: %2").arg(strScope, strKey);
-            usedSequences.insertMulti(strKey, item.key());
+            usedSequences.insert(strKey, item.key());
         }
     }
@@ -420,5 +420,8 @@
     foreach (const QString &strKey, usedSequences.keys())
         if (usedSequences.count(strKey) > 1)
-            duplicatedSequences.unite(usedSequences.values(strKey).toSet());
+        {
+            foreach (const QString &strValue, usedSequences.values(strKey))
+                duplicatedSequences |= strValue;
+        }
     /* Is there something changed? */
     if (m_duplicatedSequences != duplicatedSequences)
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsSF.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsSF.cpp	(revision 94004)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsSF.cpp	(revision 94005)
@@ -335,10 +335,10 @@
 
     /* Get actual folders: */
-    QMap<UISharedFolderType, CSharedFolder> folders;
+    QMultiMap<UISharedFolderType, CSharedFolder> folders;
     /* Load machine (permanent) folders if allowed: */
     if (isSharedFolderTypeSupported(MachineType))
     {
         foreach (const CSharedFolder &folder, getSharedFolders(MachineType))
-            folders.insertMulti(MachineType, folder);
+            folders.insert(MachineType, folder);
     }
     /* Load console (temporary) folders if allowed: */
@@ -346,5 +346,5 @@
     {
         foreach (const CSharedFolder &folder, getSharedFolders(ConsoleType))
-            folders.insertMulti(ConsoleType, folder);
+            folders.insert(ConsoleType, folder);
     }
 