Index: /trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIComboBox.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIComboBox.cpp	(revision 94041)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIComboBox.cpp	(revision 94042)
@@ -398,16 +398,28 @@
             connect(m_pComboBox, static_cast<void(QComboBox::*)(int)>(&QComboBox::activated),
                     this, static_cast<void(QIComboBox::*)(int)>(&QIComboBox::activated));
+#if QT_VERSION >= QT_VERSION_CHECK(6, 0, 0) /** @todo qt6: textActivated was added in 5.14 actually */
+            connect(m_pComboBox, static_cast<void(QComboBox::*)(const QString &)>(&QComboBox::textActivated),
+                    this, static_cast<void(QIComboBox::*)(const QString &)>(&QIComboBox::textActivated));
+#else
             connect(m_pComboBox, static_cast<void(QComboBox::*)(const QString &)>(&QComboBox::activated),
                     this, static_cast<void(QIComboBox::*)(const QString &)>(&QIComboBox::activated));
+#endif
             connect(m_pComboBox, static_cast<void(QComboBox::*)(int)>(&QComboBox::currentIndexChanged),
                     this, static_cast<void(QIComboBox::*)(int)>(&QIComboBox::currentIndexChanged));
+#if QT_VERSION < QT_VERSION_CHECK(6, 0, 0)
             connect(m_pComboBox, static_cast<void(QComboBox::*)(const QString &)>(&QComboBox::currentIndexChanged),
                     this, static_cast<void(QIComboBox::*)(const QString &)>(&QIComboBox::currentIndexChanged));
+#endif
             connect(m_pComboBox, &QComboBox::currentTextChanged, this, &QIComboBox::currentTextChanged);
             connect(m_pComboBox, &QComboBox::editTextChanged, this, &QIComboBox::editTextChanged);
+#if QT_VERSION >= QT_VERSION_CHECK(6, 0, 0) /** @todo qt6: textHighlighted was added in 5.14 actually */
+            connect(m_pComboBox, static_cast<void(QComboBox::*)(const QString &)>(&QComboBox::textHighlighted),
+                    this, static_cast<void(QIComboBox::*)(const QString &)>(&QIComboBox::textHighlighted));
+#else
             connect(m_pComboBox, static_cast<void(QComboBox::*)(const QString &)>(&QComboBox::highlighted),
                     this, static_cast<void(QIComboBox::*)(const QString &)>(&QIComboBox::highlighted));
             connect(m_pComboBox, static_cast<void(QComboBox::*)(const QString &)>(&QComboBox::highlighted),
                     this, static_cast<void(QIComboBox::*)(const QString &)>(&QIComboBox::highlighted));
+#endif
             /* Add combo-box into layout: */
             pLayout->addWidget(m_pComboBox);
Index: /trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIComboBox.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIComboBox.h	(revision 94041)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIComboBox.h	(revision 94042)
@@ -43,10 +43,16 @@
     void activated(int iIndex);
     /** Notifies listeners about user chooses an item with @a strText in the combo-box. */
+#if QT_VERSION >= QT_VERSION_CHECK(6, 0, 0) /** @todo qt6: textHighlighted was added in 5.14 actually */
+    void textActivated(const QString &strText);
+#else
     void activated(const QString &strText);
+#endif
 
     /** Notifies listeners about current item changed to item with @a iIndex. */
     void currentIndexChanged(int iIndex);
+#if QT_VERSION < QT_VERSION_CHECK(6, 0, 0)
     /** Notifies listeners about current item changed to item with @a strText. */
     void currentIndexChanged(const QString &strText);
+#endif
 
     /** Notifies listeners about current combo-box text is changed to @a strText. */
@@ -58,5 +64,9 @@
     void highlighted(int iIndex);
     /** Notifies listeners about user highlighted an item with @a strText in the popup list-view. */
+#if QT_VERSION >= QT_VERSION_CHECK(6, 0, 0) /** @todo qt6: textHighlighted was added in 5.14 actually */
+    void textHighlighted(const QString &strText);
+#else
     void highlighted(const QString &strText);
+#endif
 
 public:
Index: /trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerTable.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerTable.cpp	(revision 94041)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerTable.cpp	(revision 94042)
@@ -291,4 +291,11 @@
     if (m_pHistoryComboBox)
     {
+#if QT_VERSION >= QT_VERSION_CHECK(6, 0, 0)
+        disconnect(m_pHistoryComboBox, static_cast<void(QComboBox::*)(const QString&)>(&QComboBox::currentTextChanged),
+                   this, &UIFileManagerNavigationWidget::sltHandlePathChange);
+        m_pHistoryComboBox->clear();
+        connect(m_pHistoryComboBox, static_cast<void(QComboBox::*)(const QString&)>(&QComboBox::currentTextChanged),
+                this, &UIFileManagerNavigationWidget::sltHandlePathChange);
+#else
         disconnect(m_pHistoryComboBox, static_cast<void(QComboBox::*)(const QString&)>(&QComboBox::currentIndexChanged),
                    this, &UIFileManagerNavigationWidget::sltHandlePathChange);
@@ -296,4 +303,5 @@
         connect(m_pHistoryComboBox, static_cast<void(QComboBox::*)(const QString&)>(&QComboBox::currentIndexChanged),
                 this, &UIFileManagerNavigationWidget::sltHandlePathChange);
+#endif
     }
 
@@ -330,6 +338,11 @@
             connect(m_pHistoryComboBox, &UIFileManagerHistoryComboBox::sigHidePopup,
                     this, &UIFileManagerNavigationWidget::sltHandleHidePopup);
+#if QT_VERSION >= QT_VERSION_CHECK(6, 0, 0)
+            connect(m_pHistoryComboBox, static_cast<void(QComboBox::*)(const QString&)>(&QComboBox::currentTextChanged),
+                    this, &UIFileManagerNavigationWidget::sltHandlePathChange);
+#else
             connect(m_pHistoryComboBox, static_cast<void(QComboBox::*)(const QString&)>(&QComboBox::currentIndexChanged),
                     this, &UIFileManagerNavigationWidget::sltHandlePathChange);
+#endif
 
             m_pContainer->addWidget(m_pBreadCrumbs);
Index: /trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsSerial.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsSerial.cpp	(revision 94041)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsSerial.cpp	(revision 94042)
@@ -506,6 +506,11 @@
 {
     connect(m_pCheckBoxPort, &QCheckBox::toggled, this, &UIMachineSettingsSerial::sltGbSerialToggled);
+#if QT_VERSION >= QT_VERSION_CHECK(5, 14, 0)
+    connect(m_pComboNumber, static_cast<void(QComboBox::*)(const QString&)>(&QComboBox::textActivated),
+            this, &UIMachineSettingsSerial::sltCbNumberActivated);
+#else
     connect(m_pComboNumber, static_cast<void(QComboBox::*)(const QString&)>(&QComboBox::activated),
             this, &UIMachineSettingsSerial::sltCbNumberActivated);
+#endif
     connect(m_pLineEditIRQ, &QLineEdit::textChanged, m_pParent, &UIMachineSettingsSerialPage::revalidate);
     connect(m_pLineEditIOPort, &QLineEdit::textChanged, m_pParent, &UIMachineSettingsSerialPage::revalidate);