Index: trunk/src/VBox/Frontends/VBoxManage/VBoxManageCloud.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxManage/VBoxManageCloud.cpp	(revision 93875)
+++ trunk/src/VBox/Frontends/VBoxManage/VBoxManageCloud.cpp	(revision 94070)
@@ -2654,6 +2654,4 @@
         { "--tunnel-network-name",  't', RTGETOPT_REQ_STRING },
         { "--tunnel-network-range", 'r', RTGETOPT_REQ_STRING },
-        { "--guest-additions-iso",  'a', RTGETOPT_REQ_STRING },
-        { "--local-gateway-iso",    'l', RTGETOPT_REQ_STRING },
         { "--proxy",                'p', RTGETOPT_REQ_STRING },
         { "--compartment-id",       'c', RTGETOPT_REQ_STRING }
@@ -2669,6 +2667,4 @@
     Bstr strTunnelNetworkName;
     Bstr strTunnelNetworkRange;
-    Bstr strLocalGatewayIso;
-    Bstr strGuestAdditionsIso;
     Bstr strProxy;
     Bstr strCompartmentId;
@@ -2693,10 +2689,4 @@
             case 'r':
                 strTunnelNetworkRange=ValueUnion.psz;
-                break;
-            case 'l':
-                strLocalGatewayIso=ValueUnion.psz;
-                break;
-            case 'a':
-                strGuestAdditionsIso=ValueUnion.psz;
                 break;
             case 'p':
@@ -2718,12 +2708,5 @@
         return RTEXITCODE_FAILURE;
 
-    if (strLocalGatewayIso.isEmpty())
-        return errorArgument(Cloud::tr("Missing --local-gateway-iso parameter"));
-
     ComPtr<IVirtualBox> pVirtualBox = a->virtualBox;
-
-    hrc = createLocalGatewayImage(pVirtualBox, strLocalGatewayIso, strGuestAdditionsIso, strProxy);
-    if (FAILED(hrc))
-        return RTEXITCODE_FAILURE;
 
     RTPrintf(Cloud::tr("Setting up tunnel network in the cloud...\n"));
Index: trunk/src/VBox/Frontends/VBoxManage/VBoxManageModifyVM.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxManage/VBoxManageModifyVM.cpp	(revision 93875)
+++ trunk/src/VBox/Frontends/VBoxManage/VBoxManageModifyVM.cpp	(revision 94070)
@@ -136,4 +136,7 @@
     MODIFYVM_CABLECONNECTED,
     MODIFYVM_BRIDGEADAPTER,
+#ifdef VBOX_WITH_CLOUD_NET
+    MODIFYVM_CLOUDNET,
+#endif /* VBOX_WITH_CLOUD_NET */
     MODIFYVM_HOSTONLYADAPTER,
 #ifdef VBOX_WITH_VMNET
@@ -341,4 +344,7 @@
     OPT2("--cable-connected",               "--cableconnected",         MODIFYVM_CABLECONNECTED,            RTGETOPT_REQ_BOOL_ONOFF | RTGETOPT_FLAG_INDEX),
     OPT2("--bridge-adapter",                "--bridgeadapter",          MODIFYVM_BRIDGEADAPTER,             RTGETOPT_REQ_STRING | RTGETOPT_FLAG_INDEX),
+#ifdef VBOX_WITH_CLOUD_NET
+    OPT2("--cloud-network",                 "--cloudnetwork",           MODIFYVM_CLOUDNET,                  RTGETOPT_REQ_STRING | RTGETOPT_FLAG_INDEX),
+#endif /* VBOX_WITH_CLOUD_NET */
     OPT2("--host-only-adapter",             "--hostonlyadapter",        MODIFYVM_HOSTONLYADAPTER,           RTGETOPT_REQ_STRING | RTGETOPT_FLAG_INDEX),
 #ifdef VBOX_WITH_VMNET
@@ -1774,4 +1780,12 @@
                     CHECK_ERROR(nic, COMSETTER(AttachmentType)(NetworkAttachmentType_NATNetwork));
                 }
+#ifdef VBOX_WITH_CLOUD_NET
+                else if (!RTStrICmp(ValueUnion.psz, "cloud"))
+                {
+                    if (!fEnabled)
+                        CHECK_ERROR(nic, COMSETTER(Enabled)(TRUE));
+                    CHECK_ERROR(nic, COMSETTER(AttachmentType)(NetworkAttachmentType_Cloud));
+                }
+#endif /* VBOX_WITH_CLOUD_NET */
                 else
                 {
@@ -1817,4 +1831,27 @@
                 break;
             }
+
+#ifdef VBOX_WITH_CLOUD_NET
+            case MODIFYVM_CLOUDNET:
+            {
+                if (!parseNum(GetOptState.uIndex, NetworkAdapterCount, "NIC"))
+                    break;
+
+                ComPtr<INetworkAdapter> nic;
+                CHECK_ERROR_BREAK(sessionMachine, GetNetworkAdapter(GetOptState.uIndex - 1, nic.asOutParam()));
+                ASSERT(nic);
+
+                /* remove it? */
+                if (!RTStrICmp(ValueUnion.psz, "none"))
+                {
+                    CHECK_ERROR(nic, COMSETTER(CloudNetwork)(Bstr().raw()));
+                }
+                else
+                {
+                    CHECK_ERROR(nic, COMSETTER(CloudNetwork)(Bstr(ValueUnion.psz).raw()));
+                }
+                break;
+            }
+#endif /* VBOX_WITH_CLOUD_NET */
 
             case MODIFYVM_HOSTONLYADAPTER: