Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsElement.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsElement.cpp	(revision 94145)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsElement.cpp	(revision 94148)
@@ -1242,5 +1242,5 @@
     {
         /* Prepare editor: */
-        UIVisualStateEditor *pEditor = new UIVisualStateEditor(pPopup, true /* with label */);
+        UIVisualStateEditor *pEditor = new UIVisualStateEditor(pPopup);
         if (pEditor)
         {
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIVisualStateEditor.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIVisualStateEditor.cpp	(revision 94145)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIVisualStateEditor.cpp	(revision 94148)
@@ -29,8 +29,8 @@
 
 
-UIVisualStateEditor::UIVisualStateEditor(QWidget *pParent /* = 0 */, bool fWithLabel /* = false */)
+UIVisualStateEditor::UIVisualStateEditor(QWidget *pParent /* = 0 */)
     : QIWithRetranslateUI<QWidget>(pParent)
-    , m_fWithLabel(fWithLabel)
     , m_enmValue(UIVisualStateType_Invalid)
+    , m_pLayout(0)
     , m_pLabel(0)
     , m_pCombo(0)
@@ -68,4 +68,15 @@
 }
 
+int UIVisualStateEditor::minimumLabelHorizontalHint() const
+{
+    return m_pLabel->minimumSizeHint().width();
+}
+
+void UIVisualStateEditor::setMinimumLayoutIndent(int iIndent)
+{
+    if (m_pLayout)
+        m_pLayout->setColumnMinimumWidth(0, iIndent);
+}
+
 void UIVisualStateEditor::retranslateUi()
 {
@@ -93,15 +104,16 @@
 {
     /* Create main layout: */
-    QGridLayout *pMainLayout = new QGridLayout(this);
-    if (pMainLayout)
+    m_pLayout = new QGridLayout(this);
+    if (m_pLayout)
     {
-        pMainLayout->setContentsMargins(0, 0, 0, 0);
-        int iRow = 0;
+        m_pLayout->setContentsMargins(0, 0, 0, 0);
 
         /* Create label: */
-        if (m_fWithLabel)
-            m_pLabel = new QLabel(this);
+        m_pLabel = new QLabel(this);
         if (m_pLabel)
-            pMainLayout->addWidget(m_pLabel, 0, iRow++, 1, 1);
+        {
+            m_pLabel->setAlignment(Qt::AlignRight | Qt::AlignVCenter);
+            m_pLayout->addWidget(m_pLabel, 0, 0);
+        }
 
         /* Create combo layout: */
@@ -126,5 +138,5 @@
 
             /* Add combo-layout into main-layout: */
-            pMainLayout->addLayout(pComboLayout, 0, iRow++, 1, 1);
+            m_pLayout->addLayout(pComboLayout, 0, 1);
         }
     }
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIVisualStateEditor.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIVisualStateEditor.h	(revision 94145)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIVisualStateEditor.h	(revision 94148)
@@ -33,4 +33,5 @@
 /* Forward declarations: */
 class QComboBox;
+class QGridLayout;
 class QLabel;
 
@@ -47,7 +48,6 @@
 public:
 
-    /** Constructs visual state editor passing @a pParent to the base-class.
-      * @param  fWithLabel  Brings whether we should add label ourselves. */
-    UIVisualStateEditor(QWidget *pParent = 0, bool fWithLabel = false);
+    /** Constructs visual state editor passing @a pParent to the base-class. */
+    UIVisualStateEditor(QWidget *pParent = 0);
 
     /** Defines editor @a uMachineId. */
@@ -61,4 +61,9 @@
     /** Returns the vector of supported values. */
     QVector<UIVisualStateType> supportedValues() const { return m_supportedValues; }
+
+    /** Returns minimum layout hint. */
+    int minimumLabelHorizontalHint() const;
+    /** Defines minimum layout @a iIndent. */
+    void setMinimumLayoutIndent(int iIndent);
 
 protected:
@@ -82,7 +87,4 @@
     QUuid  m_uMachineId;
 
-    /** Holds whether descriptive label should be created. */
-    bool  m_fWithLabel;
-
     /** Holds the value to be selected. */
     UIVisualStateType  m_enmValue;
@@ -91,8 +93,10 @@
     QVector<UIVisualStateType>  m_supportedValues;
 
+    /** Holds the main layout instance. */
+    QGridLayout *m_pLayout;
     /** Holds the label instance. */
-    QLabel    *m_pLabel;
+    QLabel      *m_pLabel;
     /** Holds the combo instance. */
-    QComboBox *m_pCombo;
+    QComboBox   *m_pCombo;
 };
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsInterface.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsInterface.cpp	(revision 94145)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsInterface.cpp	(revision 94148)
@@ -144,6 +144,6 @@
     , m_pActionPool(0)
     , m_pCache(0)
+    , m_pLayout(0)
     , m_pEditorMenuBar(0)
-    , m_pLabelVisualState(0)
     , m_pEditorVisualState(0)
     , m_pLabelMiniToolBar(0)
@@ -152,5 +152,4 @@
     , m_pEditorStatusBar(0)
 {
-    /* Prepare: */
     prepare();
 }
@@ -158,5 +157,4 @@
 UIMachineSettingsInterface::~UIMachineSettingsInterface()
 {
-    /* Cleanup: */
     cleanup();
 }
@@ -300,12 +298,18 @@
 {
     m_pEditorMenuBar->setToolTip(tr("Allows to modify VM menu-bar contents."));
-    m_pLabelVisualState->setText(tr("&Visual State:"));
     m_pLabelMiniToolBar->setText(tr("Mini ToolBar:"));
+    m_pCheckBoxShowMiniToolBar->setText(tr("Show in &Full-screen/Seamless"));
     m_pCheckBoxShowMiniToolBar->setToolTip(tr("When checked, show the Mini ToolBar in full-screen and seamless modes."));
-    m_pCheckBoxShowMiniToolBar->setText(tr("Show in &Full-screen/Seamless"));
+    m_pCheckBoxMiniToolBarAlignment->setText(tr("Show at &Top of Screen"));
     m_pCheckBoxMiniToolBarAlignment->setToolTip(tr("When checked, show the Mini ToolBar at the top of the screen, rather than in "
                                                    "its default position at the bottom of the screen."));
-    m_pCheckBoxMiniToolBarAlignment->setText(tr("Show at &Top of Screen"));
     m_pEditorStatusBar->setToolTip(tr("Allows to modify VM status-bar contents."));
+
+    /* These editors have own labels, but we want them to be properly layouted according to each other: */
+    int iMinimumLayoutHint = 0;
+    iMinimumLayoutHint = qMax(iMinimumLayoutHint, m_pEditorVisualState->minimumLabelHorizontalHint());
+    iMinimumLayoutHint = qMax(iMinimumLayoutHint, m_pLabelMiniToolBar->minimumSizeHint().width());
+    m_pEditorVisualState->setMinimumLayoutIndent(iMinimumLayoutHint);
+    m_pLayout->setColumnMinimumWidth(0, iMinimumLayoutHint);
 }
 
@@ -346,9 +350,9 @@
 {
     /* Prepare main layout: */
-    QGridLayout *pLayoutMain = new QGridLayout(this);
-    if (pLayoutMain)
-    {
-        pLayoutMain->setColumnStretch(1, 1);
-        pLayoutMain->setRowStretch(4, 1);
+    m_pLayout = new QGridLayout(this);
+    if (m_pLayout)
+    {
+        m_pLayout->setColumnStretch(1, 1);
+        m_pLayout->setRowStretch(4, 1);
 
         /* Prepare menu-bar editor: */
@@ -359,22 +363,11 @@
             m_pEditorMenuBar->setMachineID(m_uMachineId);
 
-            pLayoutMain->addWidget(m_pEditorMenuBar, 0, 0, 1, 3);
+            m_pLayout->addWidget(m_pEditorMenuBar, 0, 0, 1, 3);
         }
 
-        /* Prepare visual-state label: */
-        m_pLabelVisualState = new QLabel(this);
-        if (m_pLabelVisualState)
-        {
-            m_pLabelVisualState->setAlignment(Qt::AlignRight | Qt::AlignVCenter);
-            pLayoutMain->addWidget(m_pLabelVisualState, 1, 0);
-        }
         /* Prepare visual-state editor: */
         m_pEditorVisualState = new UIVisualStateEditor(this);
         if (m_pEditorVisualState)
-        {
-            if (m_pLabelVisualState)
-                m_pLabelVisualState->setBuddy(m_pEditorVisualState);
-            pLayoutMain->addWidget(m_pEditorVisualState, 1, 1);
-        }
+            m_pLayout->addWidget(m_pEditorVisualState, 1, 0, 1, 3);
 
         /* Prepare mini-toolbar label: */
@@ -383,14 +376,14 @@
         {
             m_pLabelMiniToolBar->setAlignment(Qt::AlignRight | Qt::AlignVCenter);
-            pLayoutMain->addWidget(m_pLabelMiniToolBar, 2, 0);
+            m_pLayout->addWidget(m_pLabelMiniToolBar, 2, 0);
         }
         /* Prepare 'show mini-toolbar' check-box: */
         m_pCheckBoxShowMiniToolBar = new QCheckBox(this);
         if (m_pCheckBoxShowMiniToolBar)
-            pLayoutMain->addWidget(m_pCheckBoxShowMiniToolBar, 2, 1);
+            m_pLayout->addWidget(m_pCheckBoxShowMiniToolBar, 2, 1);
         /* Prepare 'mini-toolbar alignment' check-box: */
         m_pCheckBoxMiniToolBarAlignment = new QCheckBox(this);
         if (m_pCheckBoxMiniToolBarAlignment)
-            pLayoutMain->addWidget(m_pCheckBoxMiniToolBarAlignment, 3, 1);
+            m_pLayout->addWidget(m_pCheckBoxMiniToolBarAlignment, 3, 1);
 
         /* Prepare status-bar editor: */
@@ -399,5 +392,5 @@
         {
             m_pEditorStatusBar->setMachineID(m_uMachineId);
-            pLayoutMain->addWidget(m_pEditorStatusBar, 5, 0, 1, 3);
+            m_pLayout->addWidget(m_pEditorStatusBar, 5, 0, 1, 3);
         }
     }
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsInterface.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsInterface.h	(revision 94145)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsInterface.h	(revision 94148)
@@ -27,4 +27,5 @@
 /* Forward declarations: */
 class QCheckBox;
+class QGridLayout;
 class QLabel;
 class UIActionPool;
@@ -104,9 +105,9 @@
     /** @name Widgets
      * @{ */
+        /** Holds the main layout instance. */
+        QGridLayout             *m_pLayout;
         /** Holds the menu-bar editor instance. */
         UIMenuBarEditorWidget   *m_pEditorMenuBar;
-        /** Holds the visual state label instance. */
-        QLabel                  *m_pLabelVisualState;
-        /** Holds the visual state label instance. */
+        /** Holds the visual state editor instance. */
         UIVisualStateEditor     *m_pEditorVisualState;
         /** Holds the mini-toolbar label instance. */